-- frmMain.lua
-- written by Habna


resources = {
	  LeftBubble_TopLeftCorner = { Background = AppRes.."lbubble_top_left_corner.tga" },
	  LeftBubble_TopRightCorner = { Background = AppRes.."lbubble_top_right_corner.tga" },
	  Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	  Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	  Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	  Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	  Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	  Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },
	  Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	  RightBubble_TopLeftCorner = { Background = AppRes.."rbubble_top_left_corner.tga" },
	  RightBubble_TopRightCorner = { Background = AppRes.."rbubble_top_right_corner.tga" }
};

function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^

	ToolTipWin = nil;

	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()

	wTitanBar = Turbine.UI.Window();
	wTitanBar:SetPosition( 0, 0 );
	wTitanBar:SetSize( screenWidth, 30 );
	--wTitanBar:SetBackground( resources.TitanBar.Background );
	wTitanBar:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--wTitanBar:SetMouseVisible( false ); -- If set to false, menu will not work.
	wTitanBar:SetWantsKeyEvents( true );
	wTitanBar:SetZOrder( 10 );
	wTitanBar:SetVisible( true );

	--**v Get player backpack, Class, Race & attributes v**
	Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	
	--Client will crash if :GetAttributes is called and then the plugin is unloaded
	--wTitanBar.playerAtt = Player:GetAttributes();
	--**^
	
	-- 0x41007ed2 (Mail in game icon) or 0x41007f7a

	-- 0x41007eca (Poor server connection)
	-- 0x41007ecb (Broken server connection)
	-- 0x41007ecc (Good server connection)

		
	wTitanBar.MouseMove = function( sender, args )
		sFromCtr = nil;
	end
	
	--**v TitanBar event handlers v**
	wTitanBar.KeyDown = function( sender, args )
		if ( args.Action == 268435635 ) then -- **v Hide TitanBar if F12 key is press v**
			wTitanBar:SetVisible( not wTitanBar:IsVisible() );
		end
	end

	wTitanBar.MouseLeave = function( sender, args )
		if ToolTipWin ~= nil then
			ToolTipWin:SetVisible( false );
			ToolTipWin = nil;
		end
	end

	wTitanBar.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			if sFromCtr == nil then
				TitanBarMenu:ShowMenu();
			else
				ControlMenu:ShowMenu();
			end
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end

	wTitanBar.Unload = function( sender, args )
		--if ShowMoney then RemoveCallback(wTitanBar.playerAtt, "MoneyChanged", wTitanBar.moneyChangedHandler); end
		--if ShowDestinyPoints then RemoveCallback(wTitanBar.playerAtt, "DestinyPointsChanged", wTitanBar.dpChangedHandler); end
		if ShowBagInfos then RemoveCallback(Backpack, "ItemAdded", wTitanBar.iaHandler); end
		if ShowBagInfos then RemoveCallback(Backpack, "ItemRemoved", wTitanBar.irHandler);	end
		if ShowPlayerInfos then RemoveCallback(Player, "LevelChanged", wTitanBar.levelChangedHandler); end
		if ShowPlayerInfos then RemoveCallback(Player, "NameChanged", wTitanBar.nameChangedHandler); end
		--if ShowGameTime then RemoveCallback(Turbine.Engine.GetDate(), "TimeChanged", wTitanBar.gtChangedHandler); end
	end
	--**^ Window event handlers ^**

	if ShowMoney then
		--wTitanBar.playerAtt = Player:GetAttributes();
		--wTitanBar.moneyChangedHandler = AddCallback(wTitanBar.playerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		--import (AppDirD.."MoneyInfos");
		--UpdateMoney();
	end
	if ShowDestinyPoints then
		--wTitanBar.playerAtt = Player:GetAttributes();
		--wTitanBar.dpChangedHandler = AddCallback(wTitanBar.playerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		--import (AppDirD.."DestinyPoints");
		--UpdateDestinyPoints();
	end
	if ShowBagInfos then
		Backpack = Player:GetBackpack();
		wTitanBar.iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		wTitanBar.irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		import (AppDirD.."BagInfos");
		UpdateBackpackInfos();
	end
	if ShowPlayerInfos then
		wTitanBar.levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) PlayerLvl:SetText( Player:GetLevel() ); end);
		wTitanBar.nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) PlayerName:SetText( Player:GetName() ); end);
		import (AppDirD.."PlayerInfos");
		UpdatePlayersInfos();
	end
	if ShowGameTime then
		--wTitanBar.gtChangedHandler = AddCallback(Turbine.Engine.GetDate(), "TimeChanged", function(sender, args) UpdateGameTime(); end);
		--write(tostring(AppCtrD.."GameTime"));
		--import (AppCtrD.."GameTime");
		import (AppDirD.."GameTime");
		UpdateGameTime();
		GTTimer:SetWantsUpdates( true );
	end

	ReplaceModuleLocation();
end
-- **^