-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function ExecuteCallback(object, event, args)
    if (type(object[event]) == "function") then
        object[event](object, args);
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (type(object[event][i]) == "function") then
                    object[event][i](object, args);
                end
            end
        end
    end
end

--**v Create a ToolTip Window v**
function createToolTipWin( xOffset, yOffset, xSize, ySize, side, header, text1, text2, text3 )
	ToolTipWin = Turbine.UI.Window();
	ToolTipWin:SetSize( xSize, ySize );
	--ToolTipWin:SetBackColor( red ); -- Debug purpose
	ToolTipWin:SetMouseVisible( false );
	ToolTipWin:SetZOrder( 15 );
	ToolTipWin.xOffset = xOffset;
	ToolTipWin.yOffset = yOffset;

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	if side == "left" then
		topLeftCorner:SetBackground( resources.LeftBubble_TopLeftCorner.Background );
	elseif side == "right" then
		topLeftCorner:SetBackground( resources.RightBubble_TopLeftCorner.Background );
	end
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( ToolTipWin );
	botLeftCorner:SetPosition( 0, ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( ToolTipWin );
	BotBar:SetPosition( 15, ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( ToolTipWin );
	topRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	if side == "left" then 
		topRightCorner:SetBackground( resources.LeftBubble_TopRightCorner.Background );
	elseif side == "right" then
		topRightCorner:SetBackground( resources.RightBubble_TopRightCorner.Background );
	end
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( ToolTipWin );
	midRight:SetPosition( ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( ToolTipWin );
	botRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	
	lblheader = Turbine.UI.Label();
	lblheader:SetParent( ToolTipWin );
	lblheader:SetPosition( 10, 10 );
	lblheader:SetSize( xSize, ySize );
	lblheader:SetForeColor( blue );
	lblheader:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	lblheader:SetText( header );
	
	lbltext1 = Turbine.UI.Label();
	lbltext1:SetParent( ToolTipWin );
	lbltext1:SetPosition( 10, 25 );
	lbltext1:SetSize( xSize, 15 );
	lbltext1:SetForeColor( black );
	lbltext1:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext1:SetText( text1 );

	lbltext2 = Turbine.UI.Label();
	lbltext2:SetParent( ToolTipWin );
	lbltext2:SetPosition( 10, 45 );
	lbltext2:SetSize( xSize, 15 );
	lbltext2:SetForeColor( black );
	lbltext2:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext2:SetText( text2 );

	lbltext3 = Turbine.UI.Label();
	lbltext3:SetParent( ToolTipWin );
	lbltext3:SetPosition( 10, 60 );
	lbltext3:SetSize( xSize, 15 );
	lbltext3:SetForeColor( white );
	lbltext3:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext3:SetText( text3 );
	
	return ToolTipWin;
end

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, header text, text1, text2, text3 )
function ShowToolTipWin( ToShow )
	if ToShow == "MoneyG" then MoneyGTTW = createToolTipWin( 0, -17, string.len(L["MGh"]) * 7.5, 32, "left", L["MGh"] ); end -- Money infos Gold
	if ToShow == "MoneyS" then MoneySTTW = createToolTipWin( 0, -17, string.len(L["MSh"]) * 7.5, 32, "left", L["MSh"] ); end -- Money infos Silver
	if ToShow == "MoneyC" then MoneyCTTW = createToolTipWin( 0, -17, string.len(L["MCh"]) * 7.5, 32, "left", L["MCh"] ); end -- Money infos Copper
	if ToShow == "DP" then DPTTW = createToolTipWin( 0, -19, string.len(L["DPh"]) * 7.5, 32, "left", L["DPh"] ); end -- Destiny points
	if ToShow == "Bag" then BagInfosTTW = createToolTipWin( 0, -17, string.len(L["BIh"]) * 7.5, 45, "left", L["BIh"], L["BIt1"] ); end --Bag infos
	if ToShow == "PIcon" then  -- Player class
		local txt = L["PIICON"] .. PlayerRaceIs .. PlayerClassIs
		PITTW = createToolTipWin( 0, -17, string.len(txt) * 8.2, 32, "left", txt );
	end
	if ToShow == "PLvl" then PLTTW = createToolTipWin( 0, -17, string.len(L["PILVL"]) * 8, 32, "left", L["PILVL"] ); end -- Player level
	if ToShow == "PName" then PNTTW = createToolTipWin( 0, -17, string.len(L["PINAME"]) * 8.3, 32, "left", L["PINAME"] ); end -- Player name

	if ToShow == "GT" then GTTTW = createToolTipWin( 140, -17, string.len(L["GTh"]) * 7.5, 32, "right", L["GTh"] ); end -- Game Time

	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	ToolTipWin:SetPosition( mouseX - ToolTipWin.xOffset, mouseY - ToolTipWin.yOffset);
	ToolTipWin:SetVisible( true );
end
--**^
--**v Update money on TitanBar v**
function UpdateMoney()
	local money = wTitanBar.playerAtt:GetMoney();
	local cp = math.fmod( money, 100 ); -- Copper
	money = ( money - cp) / 100;
	local sp = math.fmod( money, 1000 ); -- Silver
	local gp = ( money - sp ) / 1000; -- Gold
	
	GoldLbl:SetText( gp );
	GoldLbl:SetPosition( 5, 0 );
	GoldLbl:SetSize( string.len(GoldLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	GoldIcon:SetPosition( GoldLbl:GetLeft() + GoldLbl:GetWidth(), 4 );

	SilverLbl:SetText( sp );
	SilverLbl:SetPosition( GoldIcon:GetLeft() + GoldIcon:GetWidth() + 5, 0 );
	SilverLbl:SetSize( string.len(SilverLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	SilverIcon:SetPosition( SilverLbl:GetLeft() + SilverLbl:GetWidth(), 4 );

	CopperLbl:SetText( cp );
	CopperLbl:SetPosition( SilverIcon:GetLeft() + SilverIcon:GetWidth() + 5, 0 );
	CopperLbl:SetSize( string.len(CopperLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	CopperIcon:SetPosition( CopperLbl:GetLeft() + CopperLbl:GetWidth(), 4 );
	
	MoneyCtr:SetSize( GoldLbl:GetWidth() + GoldIcon:GetWidth() + SilverLbl:GetWidth() + SilverIcon:GetWidth() + CopperLbl:GetWidth() + CopperIcon:GetWidth() + 15, wTitanBar:GetHeight() );
	--ReplaceModuleLocation();
end
--**^
--**v Update destiny point currencies on TitanBar v**
function UpdateDestinyPoints()
	DestinyLbl:SetText( wTitanBar.playerAtt:GetDestinyPoints() );
	DestinyLbl:SetSize( string.len(DestinyLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	DestinyIcon:SetPosition( DestinyLbl:GetLeft() + DestinyLbl:GetWidth(), 4 );

	DPCtr:SetSize( DestinyLbl:GetWidth() + DestinyIcon:GetWidth(), wTitanBar:GetHeight() );
	--ReplaceModuleLocation();
end
--**^
--**v Update backpack infos on TitanBar v**
function UpdateBackpackInfos()
	local max = Backpack:GetSize();
	local freeslots = 0;

	for i = 1, max do
		if ( Backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end
	end

	BagInfoLbl:SetText( max - freeslots .. "/" .. max );
	BagInfoLbl:SetSize( string.len(BagInfoLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght

	BagCtr:SetSize( BagInfoIcon:GetWidth() + BagInfoLbl:GetWidth(), wTitanBar:GetHeight() );
	--ReplaceModuleLocation();
end
--**^
--**v Update player infos on TitanBar v**
function UpdatePlayersInfos()
	PlayerRaceIs = Player:GetRace();
	if PlayerRaceIs == 0 then PlayerRaceIs = ""; end -- Undefined
	if PlayerRaceIs == 65 then PlayerRaceIs = L["Elf"]; end
	if PlayerRaceIs == 23 then PlayerRaceIs = L["Man"]; end
	if PlayerRaceIs == 73 then PlayerRaceIs = L["Dwarf"]; end
	if PlayerRaceIs == 81 then PlayerRaceIs = L["Hobbit"]; end

	PlayerClassIs = Player:GetClass();
	if PlayerClassIs == 23 then PlayerClassIs = L["Guardian"]; PlayerIconCodeIs = "0x41007dd8"; end
	if PlayerClassIs == 24 then PlayerClassIs = L["Captain"]; PlayerIconCodeIs = "0x41007dd7"; end
	if PlayerClassIs == 31 then PlayerClassIs = L["Minstrel"]; PlayerIconCodeIs = "0x41007dd6"; end
	if PlayerClassIs == 40 then PlayerClassIs = L["Burglar"]; PlayerIconCodeIs = "0x41007ddb"; end
	if PlayerClassIs == 162 then PlayerClassIs = L["Hunter"]; PlayerIconCodeIs = "0x41007dda"; end
	if PlayerClassIs == 172 then PlayerClassIs = L["Champion"]; PlayerIconCodeIs = "0x41007ddc"; end
	if PlayerClassIs == 185 then PlayerClassIs = L["Lore-Master"]; PlayerIconCodeIs = "0x41007dd9"; end
	if PlayerClassIs == 191 then PlayerClassIs = L["Ranger"]; PlayerIconCodeIs = "0x41007ece"; end --???  Default icon code, need real one thought
	if PlayerClassIs == 193 then PlayerClassIs = L["Rune-Keeper"]; PlayerIconCodeIs = "0x41007ece"; end --Default icon code, need real one thought
	if PlayerClassIs == 194 then PlayerClassIs = L["Warden"]; PlayerIconCodeIs = "0x41007ece"; end --Default icon code, need real one thought

	-- 0x41008500 (red eye) 32x32

	-- 0x41007ddd (Reaver class icon) 25x25 - Class no71
	-- 0x41007de0 (Weaver class icon) 25x25 - Class no127
	-- 0x41007ddf (Blackarrow class icon) 25x25 - Class no179
	-- 0x41007dde (Warleader class icon) 25x25 - Class no52
	-- 0x41007de1 (Stalker class icon) 25x25 - Class no126
	--			  (Defiler class icon) 25x25 - Class no128
	
	PlayerIcon:SetBackground( tonumber(PlayerIconCodeIs) );
	PlayerName:SetText( Player:GetName() );
	PlayerName:SetSize( string.len(PlayerName:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	PlayerLvl:SetText( Player:GetLevel() );
	PlayerLvl:SetSize( string.len(PlayerLvl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	PlayerName:SetPosition( PlayerLvl:GetLeft() + PlayerLvl:GetWidth() + 5, 0 );

	PlayerCtr:SetSize( PlayerIcon:GetWidth() + PlayerLvl:GetWidth() + PlayerName:GetWidth() + 15, wTitanBar:GetHeight() );
	--ReplaceModuleLocation();
end
--**^

--**v Update game time on TitanBar v**
function UpdateGameTime()
	local currentdate = Turbine.Engine.GetDate();
	local currenthour = currentdate.Hour;
	local currentminute = currentdate.Minute;
	
	if currentminute < 10 then currentminute = "0" .. currentminute; end
	
	GTLbl:SetText( currenthour .. ":" .. currentminute );
	GTLbl:SetSize( string.len(GTLbl:GetText()) * 8, wTitanBar:GetHeight() ); --Auto size with text lenght
	
	GTCtr:SetSize( GTLbl:GetWidth() + 5, wTitanBar:GetHeight() );
	--ReplaceModuleLocation();
end
--**^

-- **v Change TitanBar back color v**
function ChangeColor()
	if SetToAll then
		wTitanBar:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) );
		if ShowMoney then MoneyCtr:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDestinyPoints then DPCtr:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowBagInfos then BagCtr:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowPlayerInfos then PlayerCtr:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowGameTime then GTCtr:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
	else
		wTitanBar:SetBackColor( Turbine.UI.Color(bcAlpha, bcRed, bcGreen, bcBlue) );
		if ShowMoney then MoneyCtr:SetBackColor( Turbine.UI.Color(MbcAlpha, MbcRed, MbcGreen, MbcBlue) ); end
		if ShowDestinyPoints then DPCtr:SetBackColor( Turbine.UI.Color(DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue) ); end
		if ShowBagInfos then BagCtr:SetBackColor( Turbine.UI.Color(BbcAlpha, BbcRed, BbcGreen, BbcBlue) ); end
		if ShowPlayerInfos then PlayerCtr:SetBackColor( Turbine.UI.Color(PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue) ); end
		if ShowGameTime then GTCtr:SetBackColor( Turbine.UI.Color(GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue) ); end

		if sFrom == nil then wTitanBar:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "Money" then MoneyCtr:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DP" then DPCtr:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "BI" then BagCtr:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "PN" then PlayerCtr:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end

		if sFrom == "GT" then GTCtr:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
	end
end
--**^
-- **v Replace control on TitanBar v**
function ReplaceModuleLocation()
	--Module starting at left
	local ModuleLeftPos = 0;
	--if ShowMoney then MoneyCtr:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + MoneyCtr:GetWidth(); end
	--if ShowDestinyPoints then DPCtr:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + DPCtr:GetWidth(); end
	if ShowBagInfos then BagCtr:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + BagCtr:GetWidth(); end
	if ShowPlayerInfos then PlayerCtr:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + PlayerCtr:GetWidth(); end

	--Module starting at right
	local ModuleRightPos = wTitanBar:GetWidth();
	if ShowGameTime then GTCtr:SetPosition( ModuleRightPos - GTCtr:GetWidth(), 0 ); ModuleRightPos = ModuleRightPos - GTCtr:GetWidth(); end
end
--**^
-- **v Set background color v**
function SetBackgroundColor()
	if frmBG then
		wBackground:Close();
	else
		import (AppDirD.."background"); -- LUA background file
	end
	frmBackground();
end
--**^
-- **v Change TitanBar language v**
function ChangeTitanBarLanguage()
	SaveSettings();
	ReloadTitanBar();
end
--**^

-- For debug purpose
function ShowTableContent(table)
	for k,v in pairs(table) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end