-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	if GLocale == "de" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsDE" ); end
	if GLocale == "en" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsEN" ); end
	if GLocale == "fr" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsFR" ); end
	
	if settings == nil then
		TBLocale = GLocale;
		bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for TitanBar
		MbcAlpha, MbcRed, MbcGreen, MbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Money Control
		DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Destiny points Control
		BbcAlpha, BbcRed, BbcGreen, BbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Bsg Control
		PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player infos Control
		GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Game time Control
		ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowGameTime = false, false, true, true, true;
		SaveSettings();
	end

	TBLocale = settings.Language;
	--write(tostring(AppLocaleD..TBLocale));
	import (AppLocaleD..TBLocale);

	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);

	ShowMoney = settings.Show.Money.V;
	MbcAlpha = tonumber(settings.Show.Money.A);
	MbcRed = tonumber(settings.Show.Money.R);
	MbcGreen = tonumber(settings.Show.Money.G);
	MbcBlue = tonumber(settings.Show.Money.B);

	ShowDestinyPoints = settings.Show.DestinyPoints.V;
	DPbcAlpha = tonumber(settings.Show.DestinyPoints.A);
	DPbcRed = tonumber(settings.Show.DestinyPoints.R);
	DPbcGreen = tonumber(settings.Show.DestinyPoints.G);
	DPbcBlue = tonumber(settings.Show.DestinyPoints.B);

	ShowBagInfos = settings.Show.BagInfos.V;
	BbcAlpha = tonumber(settings.Show.BagInfos.A);
	BbcRed = tonumber(settings.Show.BagInfos.R);
	BbcGreen = tonumber(settings.Show.BagInfos.G);
	BbcBlue = tonumber(settings.Show.BagInfos.B);

	ShowPlayerInfos = settings.Show.PlayerInfos.V;
	PIbcAlpha = tonumber(settings.Show.PlayerInfos.A);
	PIbcRed = tonumber(settings.Show.PlayerInfos.R);
	PIbcGreen = tonumber(settings.Show.PlayerInfos.G);
	PIbcBlue = tonumber(settings.Show.PlayerInfos.B);

	ShowGameTime = settings.Show.GameTime.V;
	GTbcAlpha = tonumber(settings.Show.GameTime.A);
	GTbcRed = tonumber(settings.Show.GameTime.R);
	GTbcGreen = tonumber(settings.Show.GameTime.G);
	GTbcBlue = tonumber(settings.Show.GameTime.B);

	--if ShowGameTime then import (AppCtrD.."GameTime"); end
end
-- **^

-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.Language = TBLocale;

	settings.BackColor = {};
	settings.BackColor.A = string.format("%.3f", bcAlpha);
	settings.BackColor.R = string.format("%.3f", bcRed);
	settings.BackColor.G = string.format("%.3f", bcGreen);
	settings.BackColor.B = string.format("%.3f", bcBlue);
	
	settings.Show = {};
	settings.Show.Money = {};
	settings.Show.Money.V = ShowMoney;
	settings.Show.Money.A = string.format("%.3f", MbcAlpha);
	settings.Show.Money.R = string.format("%.3f", MbcRed);
	settings.Show.Money.G = string.format("%.3f", MbcGreen);
	settings.Show.Money.B = string.format("%.3f", MbcBlue);

	settings.Show.DestinyPoints = {};
	settings.Show.DestinyPoints.V = ShowDestinyPoints;
	settings.Show.DestinyPoints.A = string.format("%.3f", DPbcAlpha);
	settings.Show.DestinyPoints.R = string.format("%.3f", DPbcRed);
	settings.Show.DestinyPoints.G = string.format("%.3f", DPbcGreen);
	settings.Show.DestinyPoints.B = string.format("%.3f", DPbcBlue);

	settings.Show.BagInfos = {};
	settings.Show.BagInfos.V = ShowBagInfos;
	settings.Show.BagInfos.A = string.format("%.3f", BbcAlpha);
	settings.Show.BagInfos.R = string.format("%.3f", BbcRed);
	settings.Show.BagInfos.G = string.format("%.3f", BbcGreen);
	settings.Show.BagInfos.B = string.format("%.3f", BbcBlue);

	settings.Show.PlayerInfos = {};
	settings.Show.PlayerInfos.V = ShowPlayerInfos;
	settings.Show.PlayerInfos.A = string.format("%.3f", PIbcAlpha);
	settings.Show.PlayerInfos.R = string.format("%.3f", PIbcRed);
	settings.Show.PlayerInfos.G = string.format("%.3f", PIbcGreen);
	settings.Show.PlayerInfos.B = string.format("%.3f", PIbcBlue);

	settings.Show.GameTime = {};
	settings.Show.GameTime.V = ShowGameTime;
	settings.Show.GameTime.A = string.format("%.3f", GTbcAlpha);
	settings.Show.GameTime.R = string.format("%.3f", GTbcRed);
	settings.Show.GameTime.G = string.format("%.3f", GTbcGreen);
	settings.Show.GameTime.B = string.format("%.3f", GTbcBlue);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	write( TBR );
	TBLocale = "en";
	ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowGameTime  = false, false, true, true, true;
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for TitanBar
	MbcAlpha, MbcRed, MbcGreen, MbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Money Control
	DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Destiny points Control
	BbcAlpha, BbcRed, BbcGreen, BbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for bag Control
	PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player infos Control
	GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Game time Control
	SaveSettings();
	ReloadTitanBar();
end
-- **^